Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.

Bug 2001232

Summary: Review Request: fasttrack - Track multiple objects in video recording
Product: [Fedora] Fedora Reporter: Ben Beasley <code>
Component: Package ReviewAssignee: Ankur Sinha (FranciscoD) <sanjay.ankur>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: package-review, sanjay.ankur
Target Milestone: ---Flags: sanjay.ankur: fedora-review+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2021-09-20 13:33:47 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Embargoed:
Bug Depends On:    
Bug Blocks: 1276941    

Description Ben Beasley 2021-09-04 16:13:47 UTC
Spec URL: https://music.fedorapeople.org/fasttrack.spec
SRPM URL: https://music.fedorapeople.org/fasttrack-5.3.3-1.fc34.src.rpm
Description:

Tracking objects in video recording can be tedious. Existing software are
expensive, the learning curve can be steep, necessitate a powerful computer,
and the workflow can not be easily adapted when the project evolved.

FastTrack is a free (as freedom) desktop tracking software, easy to install,
easy to use, and performant. The software can be downloaded for Linux, macOS,
and Windows, and a public API is available to embed the core of the software in
any C++/Qt project.

Two main features are implemented in the software:

  • An automatic tracking algorithm that can detect and track objects
    (conserving the objects’ identities across the video recording).
  • A manual review of the tracking where errors can be corrected rapidly and
    easily to achieve 100% accuracy.

Fedora Account System Username: music

FastTrack is a relatively standard C++ Qt5 desktop application, with a standalone CLI version and some C++-based and Python-based tests.

Koji scratch builds:

F36: https://koji.fedoraproject.org/koji/taskinfo?taskID=75119335
F35: https://koji.fedoraproject.org/koji/taskinfo?taskID=75123398
F34: https://koji.fedoraproject.org/koji/taskinfo?taskID=75123225
F33: https://koji.fedoraproject.org/koji/taskinfo?taskID=75123490

This package was requested for NeuroFedora, and @neuro-sig will be granted commit privileges.

Comment 1 Ben Beasley 2021-09-04 16:14:44 UTC
https://pagure.io/neuro-sig/NeuroFedora/issue/423

Comment 2 Ankur Sinha (FranciscoD) 2021-09-06 06:15:12 UTC
Thanks Ben,

I'll review this.

Cheers,

Comment 3 Ankur Sinha (FranciscoD) 2021-09-06 08:40:15 UTC
LGTM XXXX APPROVED XXXX

Bits to look at before import:

- No harm including the desktop file for the cli, but I wonder if it needs a "Terminal=true" line there for it to run correctly.
https://specifications.freedesktop.org/desktop-entry-spec/latest/ar01s06.html

- Do we want to generate the manual pdf? I see this in the build log:
+ pandoc ../../user_manual/user_manual.html -o ../../user_manual/user_manual.pdf
pdflatex not found. Please select a different --pdf-engine or install pdflatex

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "*No copyright* GNU General Public
     License v3.0 or later", "MIT License". 412 files have unknown license.
     Detailed output of licensecheck in /home/asinha/dump/fedora-
     reviews/2001232-fasttrack/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Macros in Summary, %description expandable at SRPM build time.
     Note: Macros in: fasttrack (description), fasttrack-cli (description),
     fasttrack-doc (description)
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
^
Builds on whatever arch qt5_qtwebengine does

[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 3 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install or
     desktop-file-validate if there is such a file.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     fasttrack-cli
^
This is OK---the cli is independent of the GUI.

[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: %check is present and all tests pass.
^
Warnings and errors thrown for missing backends, but all tests pass correctly.

[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: fasttrack-5.3.3-1.fc36.x86_64.rpm
          fasttrack-cli-5.3.3-1.fc36.x86_64.rpm
          fasttrack-doc-5.3.3-1.fc36.noarch.rpm
          fasttrack-debuginfo-5.3.3-1.fc36.x86_64.rpm
          fasttrack-debugsource-5.3.3-1.fc36.x86_64.rpm
          fasttrack-5.3.3-1.fc36.src.rpm
fasttrack.x86_64: W: spelling-error %description -l en_US workflow -> work flow, work-flow, workforce
fasttrack.x86_64: W: spelling-error %description -l en_US performant -> perform ant, perform-ant, performance
fasttrack.x86_64: W: spelling-error %description -l en_US macOS -> ma Cos, mac OS, mac-OS
fasttrack.x86_64: W: no-manual-page-for-binary FastTrack
fasttrack-cli.x86_64: W: spelling-error %description -l en_US workflow -> work flow, work-flow, workforce
fasttrack-cli.x86_64: W: spelling-error %description -l en_US performant -> perform ant, perform-ant, performance
fasttrack-cli.x86_64: W: spelling-error %description -l en_US macOS -> ma Cos, mac OS, mac-OS
fasttrack-doc.noarch: W: spelling-error %description -l en_US workflow -> work flow, work-flow, workforce
fasttrack-doc.noarch: W: spelling-error %description -l en_US performant -> perform ant, perform-ant, performance
fasttrack-doc.noarch: W: spelling-error %description -l en_US macOS -> ma Cos, mac OS, mac-OS
fasttrack.src: W: spelling-error %description -l en_US workflow -> work flow, work-flow, workforce
fasttrack.src: W: spelling-error %description -l en_US performant -> perform ant, perform-ant, performance
fasttrack.src: W: spelling-error %description -l en_US macOS -> ma Cos, mac OS, mac-OS
fasttrack.src:216: W: macro-in-%changelog %autochangelog
fasttrack.src: W: patch-not-applied Patch0: 0001-Do-not-override-distribution-compiler-flags.patch
fasttrack.src: W: patch-not-applied Patch1: %{forgeurl}/commit/ff3816295f0d223d2c47a8be4ca9c523f88639a9.patch
6 packages and 0 specfiles checked; 0 errors, 16 warnings.

^
- Looks like rpmlint doesn't know about the forge and rpmautospec macros yet, but these are all OK.
- spelling suggestions are fine, but we can stick to what upstream write.


Rpmlint (debuginfo)
-------------------
Checking: fasttrack-debuginfo-5.3.3-1.fc36.x86_64.rpm
          fasttrack-cli-debuginfo-5.3.3-1.fc36.x86_64.rpm
2 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Source checksums
----------------
https://github.com/FastTrackOrg/FastTrack/archive/v5.3.3/FastTrack-5.3.3.tar.gz :
  CHECKSUM(SHA256) this package     : abd980117a18fbd4c9d2f573cf52b304a285454ff69146b9d49abe55d546faac
  CHECKSUM(SHA256) upstream package : abd980117a18fbd4c9d2f573cf52b304a285454ff69146b9d49abe55d546faac


Requires
--------
fasttrack (rpmlib, GLIBC filtered):
    hicolor-icon-theme
    libGL.so.1()(64bit)
    libQt5Core.so.5()(64bit)
    libQt5Core.so.5(Qt_5)(64bit)
    libQt5Core.so.5(Qt_5.15)(64bit)
    libQt5Gui.so.5()(64bit)
    libQt5Gui.so.5(Qt_5)(64bit)
    libQt5Network.so.5()(64bit)
    libQt5Network.so.5(Qt_5)(64bit)
    libQt5WebEngineWidgets.so.5()(64bit)
    libQt5WebEngineWidgets.so.5(Qt_5)(64bit)
    libQt5Widgets.so.5()(64bit)
    libQt5Widgets.so.5(Qt_5)(64bit)
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libgcc_s.so.1(GCC_3.3.1)(64bit)
    libm.so.6()(64bit)
    libopencv_calib3d.so.4.5()(64bit)
    libopencv_core.so.4.5()(64bit)
    libopencv_features2d.so.4.5()(64bit)
    libopencv_imgcodecs.so.4.5()(64bit)
    libopencv_imgproc.so.4.5()(64bit)
    libopencv_video.so.4.5()(64bit)
    libopencv_videoio.so.4.5()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libstdc++.so.6(CXXABI_1.3.9)(64bit)
    rtld(GNU_HASH)

fasttrack-cli (rpmlib, GLIBC filtered):
    hicolor-icon-theme
    libGL.so.1()(64bit)
    libQt5Core.so.5()(64bit)
    libQt5Core.so.5(Qt_5)(64bit)
    libQt5Core.so.5(Qt_5.15)(64bit)
    libQt5Widgets.so.5()(64bit)
    libQt5Widgets.so.5(Qt_5)(64bit)
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libgcc_s.so.1(GCC_3.3.1)(64bit)
    libm.so.6()(64bit)
    libopencv_calib3d.so.4.5()(64bit)
    libopencv_core.so.4.5()(64bit)
    libopencv_features2d.so.4.5()(64bit)
    libopencv_imgcodecs.so.4.5()(64bit)
    libopencv_imgproc.so.4.5()(64bit)
    libopencv_video.so.4.5()(64bit)
    libopencv_videoio.so.4.5()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libstdc++.so.6(CXXABI_1.3.9)(64bit)
    rtld(GNU_HASH)

fasttrack-doc (rpmlib, GLIBC filtered):

fasttrack-debuginfo (rpmlib, GLIBC filtered):

fasttrack-debugsource (rpmlib, GLIBC filtered):



Provides
--------
fasttrack:
    application()
    application(sh.fasttrack.fasttrack.desktop)
    fasttrack
    fasttrack(x86-64)
    metainfo()
    metainfo(sh.fasttrack.fasttrack.metainfo.xml)

fasttrack-cli:
    application()
    application(sh.fasttrack.fasttrackcli.desktop)
    fasttrack-cli
    fasttrack-cli(x86-64)

fasttrack-doc:
    fasttrack-doc

fasttrack-debuginfo:
    debuginfo(build-id)
    fasttrack-debuginfo
    fasttrack-debuginfo(x86-64)

fasttrack-debugsource:
    fasttrack-debugsource
    fasttrack-debugsource(x86-64)



Generated by fedora-review 0.7.6 (b083f91) last change: 2020-11-10
Command line :/usr/bin/fedora-review -b 2001232
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: fonts, R, SugarActivity, Perl, PHP, Python, Java, Haskell, Ocaml
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 4 Ben Beasley 2021-09-06 12:25:56 UTC
Thanks for the review!

> - No harm including the desktop file for the cli, but I wonder if it needs a "Terminal=true" line there for it to run correctly.
https://specifications.freedesktop.org/desktop-entry-spec/latest/ar01s06.html

You know, I tried actually using the desktop file, and I think it’s pointless. I just hadn’t returned to this review bug to say so. The CLI just prints an error message and exits promptly. So I’m just going to add a comment and default-disable that build conditional.

(It actually already has “Terminal=true”; see https://github.com/FastTrackOrg/FastTrack/blob/ff38162/sh.fasttrack.fasttrackcli.desktop#L11.)

> - Do we want to generate the manual pdf? I see this in the build log:
> + pandoc ../../user_manual/user_manual.html -o ../../user_manual/user_manual.pdf
> pdflatex not found. Please select a different --pdf-engine or install pdflatex

Yes, thanks! That’s an oversight, as you can tell from the fact that I did already BR pandoc and librsvg2-tools. I’ll add the missing BR on tex(latex). To guard against it disappearing again in the future, I’ll either change the files list to be more explicit, or possibly add --fail-if-warnings to the pandoc invocation.

Comment 5 Gwyn Ciesla 2021-09-07 13:55:52 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/fasttrack

Comment 6 Fedora Update System 2021-09-07 16:06:17 UTC
FEDORA-2021-97ca3268b7 has been submitted as an update to Fedora 33. https://bodhi.fedoraproject.org/updates/FEDORA-2021-97ca3268b7

Comment 7 Fedora Update System 2021-09-07 16:07:11 UTC
FEDORA-2021-193d240372 has been submitted as an update to Fedora 34. https://bodhi.fedoraproject.org/updates/FEDORA-2021-193d240372

Comment 8 Fedora Update System 2021-09-07 16:10:38 UTC
FEDORA-2021-ef237d560d has been submitted as an update to Fedora 35. https://bodhi.fedoraproject.org/updates/FEDORA-2021-ef237d560d

Comment 9 Fedora Update System 2021-09-07 22:25:11 UTC
FEDORA-2021-ef237d560d has been pushed to the Fedora 35 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-ef237d560d \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-ef237d560d

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 10 Fedora Update System 2021-09-08 15:18:27 UTC
FEDORA-2021-193d240372 has been pushed to the Fedora 34 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-193d240372 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-193d240372

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 11 Fedora Update System 2021-09-08 15:44:44 UTC
FEDORA-2021-97ca3268b7 has been pushed to the Fedora 33 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-97ca3268b7 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-97ca3268b7

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 12 Fedora Update System 2021-09-10 16:35:09 UTC
FEDORA-2021-ef237d560d has been submitted as an update to Fedora 35. https://bodhi.fedoraproject.org/updates/FEDORA-2021-ef237d560d

Comment 13 Fedora Update System 2021-09-10 16:35:52 UTC
FEDORA-2021-193d240372 has been submitted as an update to Fedora 34. https://bodhi.fedoraproject.org/updates/FEDORA-2021-193d240372

Comment 14 Fedora Update System 2021-09-10 16:36:35 UTC
FEDORA-2021-97ca3268b7 has been submitted as an update to Fedora 33. https://bodhi.fedoraproject.org/updates/FEDORA-2021-97ca3268b7

Comment 15 Fedora Update System 2021-09-10 22:11:14 UTC
FEDORA-2021-ef237d560d has been pushed to the Fedora 35 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-ef237d560d \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-ef237d560d

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 16 Fedora Update System 2021-09-13 03:54:33 UTC
FEDORA-2021-193d240372 has been pushed to the Fedora 34 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-193d240372 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-193d240372

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 17 Fedora Update System 2021-09-13 04:36:31 UTC
FEDORA-2021-97ca3268b7 has been pushed to the Fedora 33 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-97ca3268b7 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-97ca3268b7

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 18 Fedora Update System 2021-09-20 13:33:47 UTC
FEDORA-2021-97ca3268b7 has been pushed to the Fedora 33 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 19 Fedora Update System 2021-09-20 13:55:15 UTC
FEDORA-2021-193d240372 has been pushed to the Fedora 34 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 20 Fedora Update System 2021-09-24 20:18:07 UTC
FEDORA-2021-ef237d560d has been pushed to the Fedora 35 stable repository.
If problem still persists, please make note of it in this bug report.